Attribute VB_Name = "Mod_prem"
Public Function Premier(n As Long) As Boolean
Dim i As Long
Premier = True

If n = 1 Or n = 0 Then
   Premier = False
   Exit Function
End If



If n = 2 Or n = 3 Or n = 5 Or n = 7 Or n = 11 Or n = 13 Then
   Exit Function
End If



'Traitement des cas particuliers



For i = 1 To ((Sqr(n)) / 6) + 1

   'Si n est un entier compos (non premier) appelons p le plus petit diviseur diffrent de 1 de n.
   'Supposons que p n'est pas premier alors il existe un unique k diffrent de 1 qui divise p
   'donc n=p*p' (p tant un entier naturel)
   '      =k*k'*p'
   'donc k est un diviseur de n et k>1 et k<p
   'd'o une contradiction car le plus petit diviseur de n est p donc p est premier et p>=2
   'n=p*p'
   'et p<p' car p' diviseur de n donc suprieur  p qui est le plus petit
   'donc p*p<p*p'
   ' et donc p<sqr(n)
   'donc si n est un entier compos il existe un diviseur premier de n tel que 2<p<sqr(n)
   'par consquent si p est premier il n'en existe pas donc on peut s'arreter de vrifier  partir de sqr(n)
   
   DoEvents

   
   If (n And 1) = 0 Then
      Premier = False
      Exit Function
      'Si n pair on sort de la boucle
   End If

   
   If n Mod 3 = 0 Then
      Premier = False
      Exit For
      'Si n divisible par 3 on sort de la boucle
   End If

   
   If n Mod (6 * i - 1) = 0 Then
      Premier = False
      Exit For
   End If

   
   If n Mod (6 * i + 1) = 0 Then
      Premier = False
      Exit For
      '6i-1 et 6i+1 exclu les nombres pair ainsi que les multiples de 3 car si on arrive  cette tape on sait que n n'est divisible ni par 3 ni par 2 donc par consquent n ne sera pas divisible par 4,6,8,9...
      'si le reste de la division euclidienne de n/(6i+-1) = 0 cad n est divisible par 6i+-1 et 2<(6i+-1)<n donc n n'est pas premier
   End If


Next i


End Function


Function compose(n As Long) As Long
Dim i As Long

'On se propose ici de chercher un diviseur du nombre n
'qui nous prouve que n n'est pas premier

For i = 1 To Sqr(n)
If n Mod i = 0 Then
compose = i
End If
Next i

End Function
